Bug 151257 - reflect.UndeclaredThrowableException at $Proxy5.propertyChange
reflect.UndeclaredThrowableException at $Proxy5.propertyChange
Status: NEW
Product: soa
Classification: Unclassified
Component: -- Other --
6.x
All All
: P2 (vote)
: 6.x
Assigned To: Venkat Chellasamy
issues@soa
http://statistics.netbeans.org/except...
EXCEPTIONS_REPORT
: THREAD
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2008-10-24 11:46 UTC by rajivderas
Modified: 2009-10-14 17:11 UTC (History)
8 users (show)

See Also:
Issue Type: DEFECT
:


Attachments
stacktrace (15.49 KB, text/plain)
2008-10-31 06:40 UTC, rajivderas
Details
stacktrace (195 bytes, text/plain)
2008-12-02 12:38 UTC, Martin Fousek
Details
stacktrace (10.59 KB, text/plain)
2009-03-25 15:25 UTC, avp
Details
stacktrace (10.51 KB, text/plain)
2009-04-03 06:30 UTC, shaidan
Details

Note You need to log in before you can comment on or make changes to this bug.
Description rajivderas 2008-10-24 11:46:30 UTC
Build: NetBeans IDE Dev (Build 200810230201)
VM: Java HotSpot(TM) Client VM, 11.0-b15, Java(TM) SE Runtime Environment, 1.6.0_10-b33
OS: Windows XP, 5.1, x86
User comments: was checking target component list in project properties of soa composite  application
STACKTRACE: (first 10 lines)
java.lang.reflect.UndeclaredThrowableException
        at $Proxy.propertyChange(.java:0)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1213)
        at org.openide.nodes.Node.fireIconChange(Node.java:1027)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1207)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1170)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1213)
        at org.openide.nodes.Node.fireIconChange(Node.java:1027)
        at
org.netbeans.modules.compapp.projects.jbi.ui.JbiLogicalViewProvider$JbiLogicalViewRootNode.access$1500(JbiLogicalViewProvider.java:328)
        at
org.netbeans.modules.compapp.projects.jbi.ui.JbiLogicalViewProvider$JbiLogicalViewRootNode$BrokenLinksAction.disable(JbiLogicalViewProvider.java:642)
        at
org.netbeans.modules.compapp.projects.jbi.ui.JbiLogicalViewProvider$JbiLogicalViewRootNode$BrokenLinksAction.propertyChange(JbiLogicalViewProvider.java:627)
Comment 1 Lukas Hasik 2008-10-24 12:23:53 UTC
again possible deadlock, please evaluate
Comment 2 Sergey Lunegov 2008-10-29 13:25:12 UTC
Please provide exact steps how to reproduce the issue.
Comment 3 rajivderas 2008-10-31 06:40:41 UTC
Build: NetBeans IDE Dev (Build 200810301401)
VM: Java HotSpot(TM) Client VM, 11.0-b15, Java(TM) SE Runtime Environment, 1.6.0_10-b33
OS: Windows XP, 5.1, x86

User Comments: 


Stacktrace: 
java.lang.reflect.UndeclaredThrowableException
        at $Proxy.propertyChange(.java:0)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1213)
        at org.openide.nodes.Node.fireIconChange(Node.java:1027)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1207)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1170)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1213)
Comment 4 rajivderas 2008-10-31 06:40:46 UTC
Created attachment 72962 [details]
stacktrace
Comment 5 rajivderas 2008-10-31 06:42:55 UTC
steps:
1) Create composite soa application
2) goto its project properties
3) select build > packaging project
4) select a target component from target component list
5) in the run>running project the server is not selected and do not select it and press ok button
Comment 6 Martin Fousek 2008-12-02 12:38:29 UTC
Build: NetBeans IDE Dev (Build 081201)
VM: Java HotSpot(TM) Client VM, 10.0-b23, Java(TM) SE Runtime Environment, 1.6.0_07-b06
OS: Linux, 2.6.24-21-generic, i386

User Comments: 


Stacktrace: 
java.lang.reflect.UndeclaredThrowableException
Comment 7 Martin Fousek 2008-12-02 12:38:33 UTC
Created attachment 74396 [details]
stacktrace
Comment 8 Martin Fousek 2008-12-02 12:41:26 UTC
Exception appears, when...
1, I create EAR project on glassfish server
2, I switch into Services View and delete the chosen server
3, I switch back info Project View
-> exception
Comment 9 Tientien Li 2009-01-13 22:41:45 UTC
Will look at this one when merging into trunk in NB7.0
Comment 10 Exceptions Reporter 2009-02-27 11:26:22 UTC
This issue has already 5 duplicates 
see http://statistics.netbeans.org/exceptions/detail.do?id=132804
Comment 11 avp 2009-03-25 15:25:34 UTC
Build: NetBeans IDE Dev (Build 200903231401)
VM: Java HotSpot(TM) 64-Bit Server VM, 11.0-b16, Java(TM) SE Runtime Environment, 1.6.0_11-b03
OS: Linux, 2.6.27.7-9-default, amd64

User Comments: 


Stacktrace: 
java.lang.reflect.UndeclaredThrowableException
        at $Proxy5.propertyChange(.java:0)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1230)
        at org.openide.nodes.Node.fireIconChange(Node.java:1038)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1208)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1171)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1230)
Comment 12 avp 2009-03-25 15:25:46 UTC
Created attachment 78830 [details]
stacktrace
Comment 13 shaidan 2009-04-03 06:29:50 UTC
Build: NetBeans IDE Dev (Build 200903170201)
VM: Java HotSpot(TM) Client VM, 10.0-b23, Java(TM) SE Runtime Environment, 1.6.0_07-b06
OS: Windows XP, 5.1, x86

User Comments: 


Stacktrace: 
java.lang.reflect.UndeclaredThrowableException
        at $Proxy5.propertyChange(.java:0)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1230)
        at org.openide.nodes.Node.fireIconChange(Node.java:1038)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1208)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1171)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1230)
Comment 14 shaidan 2009-04-03 06:30:01 UTC
Created attachment 79338 [details]
stacktrace
Comment 15 Tientien Li 2009-04-10 22:19:06 UTC
We could not reproduce this problem in soa-dev65 branch following steps provided by rajvderas with jbi manager.

Since stacktrace submitted by avp and shaidan were generated by CND projects not SOA, this issues should be reassigned 
to CND component.
Comment 16 Thomas Preisler 2009-04-14 18:51:41 UTC
I looked at all the stacktraces and some are triggered by CND code but other are not so I'm not sure the problem is in CND. Here is the common pattern:

...
        at org.openide.nodes.Node.fireIconChange(Node.java:1027)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1207)
        at org.openide.nodes.FilterNode$NodeAdapter.propertyChange(FilterNode.java:1170)
        at org.openide.nodes.Node.fireOwnPropertyChange(Node.java:1213)
        at org.openide.nodes.Node.fireIconChange(Node.java:1027)
        at org.netbeans.modules.compapp.projects.jbi.ui.JbiLogicalViewProvider$JbiLogicalViewRootNode.access$1500(JbiLogicalViewProvider.java:328)
...


...
        at org.openide.nodes.Node.fireIconChange(Node.java:1027)
        at org.netbeans.modules.jee.earproject.ui.JeeArchiveLogicalViewProvider$ArchiveLogicalViewRootNode.access$800(JeeArchiveLogicalViewProvider.java:263)
        at org.netbeans.modules.jee.earproject.ui.JeeArchiveLogicalViewProvider$ArchiveLogicalViewRootNode$BrokenServerAction.checkMissingServer(JeeArchiveLogicalViewProvider.java:542)
        at org.netbeans.modules.jee.earproject.ui.JeeArchiveLogicalViewProvider$ArchiveLogicalViewRootNode$BrokenServerAction.propertyChange(JeeArchiveLogicalViewProvider.java:522)
...

...
        at org.openide.nodes.Node.fireIconChange(Node.java:1038)
        at org.netbeans.modules.cnd.makeproject.ui.MakeLogicalViewProvider$LogicalFolderNode.stateChanged(MakeLogicalViewProvider.java:905)
        at org.netbeans.modules.cnd.makeproject.api.configurations.Folder.fireChangeEvent(Folder.java:896)
        at org.netbeans.modules.cnd.makeproject.api.configurations.Folder.fireChangeEvent(Folder.java:885)
        at org.netbeans.modules.cnd.makeproject.api.configurations.Folder.addElement(Folder.java:396)
        at org.netbeans.modules.cnd.makeproject.api.configurations.Folder.addFolder(Folder.java:459)
...

I cannot reproduce the exception either so I'm not sure what to do. I think the iz should be evaluated by owner of the 'Node'.
Comment 17 t_h 2009-04-15 14:21:00 UTC
It is assert from issue 148066 which should reveal possible deadlocks. In this issue several issues are mixed together,
some of them can be already fixed. Latest exception reports come from CND so I suggest fix problem in CND (if not fixed
already) and reassign to other project from exc. rep.
Comment 18 mslama 2009-04-15 16:17:11 UTC
Filesystem events should be either fired out of PM.mutex or filesystem events should be processed asynchronously.
Comment 19 mslama 2009-04-15 16:18:51 UTC
Jesse is it possible to use fs atomic block in ProjectGenerator so that fs events would be fired out of PM.mutex?
Comment 20 Jesse Glick 2009-04-15 16:31:05 UTC
Using an "atomic" block is fine so long as you remember that it is not "atomic" at all; it simply delays firing of
changes until the end of the block. It will not make firing "asynchronous", nor we would want that to begin with -
asynchronous change firing is a nightmare for testability and predictability. The rule is:

- Listeners, or any other callbacks, should assume that they may be called with arbitrary unknown locks held. They may
not attempt to acquire any locks (*) or do anything else which might block.

In this case, JbiLogicalViewProvider$JbiLogicalViewRootNode$BrokenLinksAction.disable (or MakeProject etc.) should be
firing icon changes asynchronously, outside the dynamic scope of the listener. (BTW it would be helpful to have
convenience methods to call Node.fire*Change, Children.Keys.setKeys, etc. which would wrap the call in
EventQueue.invokeLater - this is a very common task and it is irritating to write lots of anonymous Runnable
implementations. Language support for closures would make it a little more pleasant of course.)


(*) Except for private locks which are only held while processing a small block of code. E.g. it is OK to call

synchronized (someMap) {
  if (!someMap.containsKey(k)) someMap.put(k, v);
}

from within a listener, so long as all other code synchronizing on someMap is doing something similarly trivial.
Comment 21 Thomas Preisler 2009-04-16 19:57:25 UTC
Jesse, thanks for the explanation. It was very helpful. Fixed the CND side and now passing it on to next project.
Comment 22 Quality Engineering 2009-04-17 19:57:19 UTC
Integrated into 'main-golden', will be available in build *200904171401* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main-golden/rev/306701f79d01
User: Thomas Preisler <thp@netbeans.org>
Log: #151257 reflect.UndeclaredThrowableException at $Proxy5.propertyChange
Comment 23 Exceptions Reporter 2009-10-14 17:11:53 UTC
This issue already has 10 duplicates 
see http://statistics.netbeans.org/exceptions/detail.do?id=132804


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo